//===========================================================================//
// Program......: Calculator
// Programmer...: Marcos Antonio Gambeta
// Created at...: 13/01/2004 11:00:00
// Updated at...: 14/01/2004 00:10:47
//===========================================================================//
// This program is an adaptation of an example that follows
// Visual Basic 5. The original program can be found (for those who have the
// VB5) in the folder: C: \ Program Files \ DevStudio \ VB \ samples \ PGuide \ calc.
// If you improve or expand the capabilities of this calculator, be sure to
// Send a copy to the author's original adaptation. In this case, I. :-)
//===========================================================================//
// Last UpDate at : 09/02/2010
// Updated by     : Paulo Srgio Duro (Vanguarda) - Americana - SP - Brasil
// vanguarda.one@gmail.com
//===========================================================================//
// Added new functions: Memory value now avaliable. Now, you can put entry value from
// keyboard. HotKey for operations like "+" "-" "/" "*" and for manager menory.
// Added function that move the result of expression on ClipBoard of windows, when
// the calc is closed.
//===========================================================================//
//Follow the HotKeys
// C or c = CancelEntry_Click()
// R or r = Cancel_CLick()
// W or w = CancelMemo_Click()
// S or s = ReadMemo_Click()
// M or m = SMemo_Click()
// A or a = AddMemo_Click()
// ESC to Close
//===========================================================================//

#include "hmg.ch"
#include "common.ch"

//===========================================================================//
// Statics variables
//===========================================================================//

Static nOp1,nOp2         // Store the values entered
Static lDecimalFlag      // Indicates whether there is already a decimal point in value
Static nNumOps           // Number of values entered
Static cLastInput        // Store the last key pressed
Static cOpFlag           // Indicates the pending operation
Static cTempReadout
Static nMemo             // Memory Calculator
//===========================================================================//
// Form main
//===========================================================================//
Function ShowCalc(lRetu_ClipBoard, nInitialValue)
	private cInitialValue := "0."
	
   Default lRetu_ClipBoard	:= .t.
   Default nInitialValue	:= 0
   
   cInitialValue := alltrim(str(nInitialValue))

	DEFINE WINDOW Calc ;
		AT 0,0 ;
		WIDTH 260 HEIGHT 228 ;
		TITLE "Calc - press F3 to paste calculated value" ;
		MODAL ;
		NOSIZE ;
		FONT "Arial" SIZE 12 ON INIT Form_Load();
		ON RELEASE Get_Value() 
	  
      // visor
      @ 007,023 TEXTBOX ReadOut  VALUE cInitialValue WIDTH 224 HEIGHT 25 READONLY RIGHTALIGN NOTABSTOP
      @ 007,009 TEXTBOX ReadFunc VALUE " "  WIDTH 15  HEIGHT 25 READONLY RIGHTALIGN NOTABSTOP
      @ 040,121 TEXTBOX ReadHide VALUE " "  WIDTH 15  HEIGHT 25 NOTABSTOP ON CHANGE EvalKeys() ON ENTER Operator_Click("=") INVISIBLE
      // 7 8 9 C CE MC
      @ 040,008 BUTTON btnN7  CAPTION "7"  ACTION Number_Click(7)     WIDTH 32 HEIGHT 32
      @ 040,048 BUTTON btnN8  CAPTION "8"  ACTION Number_Click(8)     WIDTH 32 HEIGHT 32
      @ 040,088 BUTTON btnN9  CAPTION "9"  ACTION Number_Click(9)     WIDTH 32 HEIGHT 32
      @ 040,136 BUTTON btnC   CAPTION "C"  ACTION Cancel_Click()      WIDTH 32 HEIGHT 32
      @ 040,176 BUTTON btnCE  CAPTION "CE" ACTION CancelEntry_Click() WIDTH 32 HEIGHT 32
      @ 040,216 BUTTON btnMC  CAPTION "MC" ACTION CancelMemo_Click()  WIDTH 32 HEIGHT 32
      // 4 5 6 + - MR
      @ 080,008 BUTTON btnN4  CAPTION "4"  ACTION Number_Click(4)     WIDTH 32 HEIGHT 32
      @ 080,048 BUTTON btnN5  CAPTION "5"  ACTION Number_Click(5)     WIDTH 32 HEIGHT 32
      @ 080,088 BUTTON btnN6  CAPTION "6"  ACTION Number_Click(6)     WIDTH 32 HEIGHT 32
      @ 080,136 BUTTON btnOA  CAPTION "+"  ACTION Operator_Click("+") WIDTH 32 HEIGHT 32
      @ 080,176 BUTTON btnOS  CAPTION "-"  ACTION Operator_Click("-") WIDTH 32 HEIGHT 32
      @ 080,216 BUTTON btnMR  CAPTION "MR" ACTION ReadMemo_Click()    WIDTH 32 HEIGHT 32
      // 1 2 3 X / MS
      @ 120,008 BUTTON btnN1  CAPTION "1"  ACTION Number_Click(1)     WIDTH 32 HEIGHT 32
      @ 120,048 BUTTON btnN2  CAPTION "2"  ACTION Number_Click(2)     WIDTH 32 HEIGHT 32
      @ 120,088 BUTTON btnN3  CAPTION "3"  ACTION Number_Click(3)     WIDTH 32 HEIGHT 32
      @ 120,136 BUTTON btnOM  CAPTION "X"  ACTION Operator_Click("X") WIDTH 32 HEIGHT 32
      @ 120,176 BUTTON btnOD  CAPTION "/"  ACTION Operator_Click("/") WIDTH 32 HEIGHT 32
      @ 120,216 BUTTON btnMS  CAPTION "MS" ACTION SMemo_Click()       WIDTH 32 HEIGHT 32
      // 0 . = % M+
      @ 160,008 BUTTON btnN0  CAPTION "0"  ACTION Number_Click(0)     WIDTH 72 HEIGHT 32
      @ 160,088 BUTTON btnDot CAPTION "."  ACTION Decimal_Click()     WIDTH 32 HEIGHT 32
      @ 160,136 BUTTON btnOI  CAPTION "="  ACTION Operator_Click("=") WIDTH 32 HEIGHT 32
      @ 160,176 BUTTON btnOP  CAPTION "%"  ACTION Percent_Click()     WIDTH 32 HEIGHT 32
      @ 160,216 BUTTON btnMP  CAPTION "M+" ACTION AddMemo_Click()     WIDTH 32 HEIGHT 32
	END WINDOW

   nMemo := 0
   ON KEY ESCAPE of Calc ACTION Calc.Release
   ON KEY F3 of Calc ACTION Akcja_F3_Calc()
   Calc.Center
   Calc.Activate

   if lRetu_ClipBoard
      To_ClipBoard()
   endif

Return nOp1
function Akcja_F3_Calc
	//msgbox('wcinito F3')
	if IsWindowActive(CALC)
		lRetu_Clipboard := .t.
		Calc.Release
	endif
return
//---------------------------------------------------------------------------//
// The initialization routine of the form.
// Set the initial values of variables.
//---------------------------------------------------------------------------//
Static Function Form_Load()

    System.ClipBoard := ""

    lDecimalFlag := .f.
    nNumOps := 2
    cLastInput := "NONE"
    cOpFlag := "="
    Calc.Readout.Value := cInitialValue
	cInitialValue := "0."
    nOp1  := val(Calc.Readout.Value)
    nOp2  := 0
	Operator_Click( "=" )
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' of button "C" (CANCEL)
// Reset text control ReadOut and clean the variables
//---------------------------------------------------------------------------//
Static Function Cancel_Click()

   Calc.Readout.Value := "0."
   Calc.ReadFunc.Value := ""
   nOp1 := 0
   nOp2 := 0
   Form_Load()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' of button "CE" (CANCEL ENTRY)
// Cancel value on ReadOut (TextBox)
//---------------------------------------------------------------------------//
Static Function CancelEntry_Click()

    Calc.Readout.Value := "0."
    lDecimalFlag := .f.
    cLastInput := "CE"
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' of button "." (DECIMAL POINT)
// If the last button pressed, was an operator, show on ReadOut (TextBox)
// the value "0.". Case not, add a decimal point into ReadOut
//---------------------------------------------------------------------------//
Static Function Decimal_Click()

    If cLastInput = "NEG"
        Calc.Readout.Value := "-0."
    ElseIf cLastInput <> "NUMS"
        Calc.Readout.Value := "0."
    EndIf
    lDecimalFlag := .t.
    cLastInput := "NUMS"
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' for the buttons of 0 to 9 (NUMBERS KEYS)
// Add the new number into ReadOut (TextBox)
//---------------------------------------------------------------------------//
Static Function Number_Click( nIndex )

    If cLastInput <> "NUMS"
       Calc.Readout.Value := "."
       lDecimalFlag := .f.
    EndIf
    If lDecimalFlag
       Calc.Readout.Value := Calc.Readout.Value + Str(nIndex,1)
    Else
       Calc.Readout.Value := Left(Calc.Readout.Value,At(".",Calc.Readout.Value)-1)+Str(nIndex,1)+"."
    EndIf
    If cLastInput = "NEG"
       Calc.Readout.Value := "-" + Calc.Readout.Value
    endif
    cLastInput = "NUMS"
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' for the button "%" (PERCENT KEY)
// Calculate and show, the percentual of first value
//---------------------------------------------------------------------------//
Static Function Percent_Click()

   Calc.Readout.Value := AllTrim(Str(Val(Calc.Readout.Value)/100))
   Calc.ReadFunc.Value := "%"
   cLastInput := "Ops"
   cOpFlag := "%"
   nNumOps := nNumOps + 1
   lDecimalFlag := .t.
   Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' for the keys "+-x/=" (OPERATOR KEYS)
// If the last button pressed was a number, or part this.
// Increment the nNumOps. If a operand be present, define nOp1.
// If two operand are presenteso, define nOp1 like the result of the
// operation from nOp1 and current value and show the results
//---------------------------------------------------------------------------//
Static Function Operator_Click( cIndex )

    cTempReadout := Calc.Readout.Value

    Calc.ReadFunc.Value := cIndex

    If cLastInput = "NUMS"
        nNumOps := nNumOps + 1
    EndIf
    Do Case
    Case nNumOps = 0
        If cIndex = "-" .And. cLastInput <> "NEG"
            Calc.Readout.Value := "-" + Calc.Readout.Value
            cLastInput := "NEG"
        EndIf
    Case nNumOps = 1
        nOp1 := Val( Calc.Readout.Value )
        If cIndex = "-" .And. cLastInput <> "NUMS" .And. cOpFlag <> "="
            Calc.Readout.Value := "-"
            cLastInput := "NEG"
        EndIf
    Case nNumOps = 2
        nOp2 := Val(cTempReadout)
        Do Case
        Case cOpFlag = "+"
           nOp1 := nOp1 + nOp2
        Case cOpFlag = "-"
           nOp1 := nOp1 - nOp2
        Case cOpFlag = "X"
           nOp1 := nOp1 * nOp2
        Case cOpFlag = "/"
           If nOp2 = 0
              MsgInfo("Division by 0 (zero) not allowed.","Calc")
           Else
              nOp1 := nOp1 / nOp2
           EndIf
        Case cOpFlag = "="
           nOp1 := nOp2
        Case cOpFlag = "%"
           nOp1 := nOp1 * nOp2
        Endcase
        Calc.Readout.Value := AllTrim(Str(nOp1))
        nNumOps := 1
    Endcase
    If cLastInput <> "NEG"
        cLastInput := "OPS"
        cOpFlag := cIndex
    EndIf
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// This function clean the variable used for add value into memory
//---------------------------------------------------------------------------//
Static Function CancelMemo_Click
	nMemo := 0
	SetProperty("Calc","btnMS","FontBold",.F.)
	Calc.ReadHide.SetFocus()
Return Nil

//---------------------------------------------------------------------------//
// This function show in ReadOut (TextBox) the value in memory (nMemo)
//---------------------------------------------------------------------------//
Static Function ReadMemo_Click

	Local i := 0
	If !Empty(nMemo)
		Calc.Readout.Value := ""
		for i := 1 to Len(Alltrim(Str(nMemo)))
			iif(Alltrim(SubStr(Alltrim(Str(nMemo)),i,1)) # ".",;
			    Number_Click(Val(Alltrim(SubStr(Alltrim(Str(nMemo)),i,1)))),;
				iif(Len(Alltrim(Str(nMemo))) # i, Decimal_Click(),))
		next i
	endif
	Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// This function, move to memory (nMemo) the value of ReadOut (TxtBox)
//---------------------------------------------------------------------------//
Static Function SMemo_Click

	if !Empty(Calc.Readout.Value) .and. Val(Calc.Readout.Value) > 0
		nMemo := Val(Calc.Readout.value)
		SetProperty("Calc","btnMS","FontBold",.T.)
		Calc.ReadHide.SetFocus()
	endif

Return Nil

//---------------------------------------------------------------------------//
// This function add the value from ReadOut (TextBox) into memory
//---------------------------------------------------------------------------//
Static Function AddMemo_Click

	if !Empty(Calc.Readout.Value) .and. Val(Calc.Readout.Value) > 0
		nMemo := nMemo + Val(Calc.Readout.Value)
		SetProperty("Calc","btnMS","FontBold",.T.)
	endif
	Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// This function evaluates the keys you type, to perform the functions of
// Calculator keyboard
//---------------------------------------------------------------------------//
Static Function EvalKeys()

	Local c_Keys
	if !Empty(Calc.ReadHide.Value)
		c_Keys := Alltrim(Calc.ReadHide.Value)
		do case
			case c_Keys == "0" .or.;
				 c_Keys == "1" .or.;
				 c_Keys == "2" .or.;
				 c_Keys == "3" .or.;
				 c_Keys == "4" .or.;
				 c_Keys == "5" .or.;
				 c_Keys == "6" .or.;
				 c_Keys == "7" .or.;
				 c_Keys == "8" .or.;
				 c_Keys == "9"
					Number_Click(Val(Alltrim(c_Keys)))
			case c_Keys == "/"
					Operator_Click("/")
			case c_Keys == "*"
					Operator_Click("X")
			case c_Keys == "-"
					Operator_Click("-")
			case c_Keys == "+"
					Operator_Click("+")
			case c_Keys == "."
					Decimal_Click()
			case c_Keys == "C" .or. c_Keys == "c"
					CancelEntry_Click()
			case c_Keys == "R" .or. c_Keys == "r"
					Cancel_Click()
			case c_Keys == "W" .or. c_Keys == "w"
					CancelMemo_Click()
			case c_Keys == "S" .or. c_Keys == "s"
					ReadMemo_Click()
			case c_Keys == "M" .or. c_Keys == "m"
					SMemo_Click()
			case c_Keys == "A" .or. c_Keys == "a"
					AddMemo_Click()
		end case
		Calc.ReadHide.Value := ""
	endif

Return Nil

//---------------------------------------------------------------------------//
// This function add the result of operation into clipboard
//---------------------------------------------------------------------------//
Static Function To_ClipBoard

	System.Clipboard := Alltrim(Str(nOp1))

Return Nil

//---------------------------------------------------------------------------//
// This function add the result of operation into nOP1 variable
//---------------------------------------------------------------------------//
Static Function Get_Value

       nOp1 := Val(Alltrim(Calc.ReadOut.Value))

Return Nil
//===========================================================================//